<script setup lang="ts">
import { useRouter, useRoute } from 'vue-router'
import { ref, computed, inject, provide, watch } from 'vue'
import { useQuery, useMutation } from '@vue/apollo-composable'
import StarIcon from 'vue-material-design-icons/Star.vue';
import GenderFemaleIcon from 'vue-material-design-icons/GenderFemale.vue';
import GenderMaleIcon from 'vue-material-design-icons/GenderMale.vue';
import CloseIcon from 'vue-material-design-icons/Close.vue';
import MinusIcon from 'vue-material-design-icons/Minus.vue';
import gql from 'graphql-tag'
import VPagination from "@hennge/vue3-pagination";
import "@hennge/vue3-pagination/dist/vue3-pagination.css";

const page = ref(1)
const search = ref('')
const searchCat = ref('')
const router = useRouter()
const route = useRoute()
const starredCharacters = ref(JSON.parse(localStorage.getItem("starredCharacters")!) || []);
const previous = ref();

const props = defineProps({
  list: String,
})

function updateFilters(){
  page.value = Number(route.query.p ?? 1);
  searchCat.value = String(route.query.c).toLowerCase();
  search.value = String(route.query.s).toLowerCase();
}
updateFilters();

const searchObj = computed(() => searchCat.value != 'undefined' && search.value != 'undefined' ? { [searchCat.value]: search.value } : {});

const variables = ref({
  page: computed(() => page.value ?? 1),
  search: computed(() => searchObj.value ?? {}),
  ids: computed(() => props.list === 'starred' ? starredCharacters.value : search.value ?? '')
})

const IS_STARRED = gql`
  mutation updateCharacterStarred($id: ID!, $isStarred: Boolean) {
        updateCharacterStarred(id: $id, isStarred: $isStarred) @client{
          id:id,
          isStarred:isStarred
        }
    }
`;

const { mutate: dodaj, onDone } = useMutation(IS_STARRED);

const GET_CHARACTERS = computed(() => searchCat.value === 'id' || props.list === 'starred' ? gql`
  query getCharactersByIds($ids: [ID!]!) {
    charactersByIds(ids: $ids) {
      id,
      name,
      image,
      status,
      isStarred @client
      episode{
        id,
        episode, 
        name
      },
      gender,
      species
    }
  }
` : searchCat.value === "episode" ? 
gql`
  query getCharactersByEp($ids: ID!) {
    episode(id: $ids) {
      name,
      episode
      characters {
        id,
        name,
        image,
        status,
        isStarred @client
        episode{
          id,
          episode, 
          name
        },
        gender,
        species
      },
    }
}
`
: gql`
  query getCharacters($page: Int, $search: FilterCharacter) {
    characters(page: $page, filter: $search) {
      info {
        count,
        pages,
        next,
        prev
      }
      results {
        isStarred @client
        id,
        name,
        image,
        status,
        episode{
          id,
          episode, 
          name
        },
        gender,
        species
      }
    }
  }
`
);
    
const { result, loading, error } = useQuery( GET_CHARACTERS, variables )

watch(() => route.query, () => {
  updateFilters();
});

function updatePage(to: any){
  if(search.value != 'undefined' && searchCat.value != 'undefined'){
    router.push({  path: '/', query: { p: to, s: search.value, c: searchCat.value } });
  } else {
    router.push({  path: '/', query: { p: to } });
  }

}

const characters = computed(() => searchCat.value === 'id' || props.list === 'starred' ? result?.value?.charactersByIds : searchCat.value === "episode" ? result?.value?.episode?.characters : result?.value?.characters?.results ?? [] )
const queryInfo = computed(() => result?.value?.characters?.info ?? result?.value?.episodes?.info ?? [])
</script>

<template>
  <main>
    <section id="character-list">
      <div class="list-header not-mobile">
        <div>Photo</div>
        <div>Character ID</div>
        <div>Name</div>
        <div>Gender</div>
        <div>Species</div>
        <div>Last Episode</div>
        <div>Add To Favorites</div>
      </div>

      <div v-for="(character) of characters" :key="character.id">
        <div class="character-photo"><img :src="character.image ?? 'https://fwcdn.pl/cpo/06/38/638/970.4.jpg'" /></div>
        <div><p class="mobile">Character ID: </p>{{ character.id ?? 'Loading...' }}</div>
        <div><p class="mobile">Name: </p>{{ character.name ?? 'Loading...' }}</div>
        <div class="gender-icon" >
          <p class="mobile">Gender: </p>
          <GenderMaleIcon v-if="character.gender==='Male'" />
          <GenderFemaleIcon v-if="character.gender==='Female'" />
          <CloseIcon v-if="character.gender==='Genderless'" />
          <MinusIcon v-if="character.gender==='unknown'" />
          {{ character.gender ?? 'Loading...' }}
        </div>
        <div><p class="mobile">Species: </p>{{ character.species ?? 'Loading...' }}</div>
        <div :alt="character.episode[character.episode.length-1]?.name" @click="router.push({ path: '/', query: { s: character.episode[character.episode.length-1]?.id, c: 'episode' } })" class="clickable"><p class="mobile">Last Episode: </p>{{ character.episode[character.episode.length-1]?.episode ?? 'Loading...' }}</div>
        <div><p class="favourite-button clickable" :class="{ 'starred-character': character.isStarred }" @click="dodaj({id:character.id,isStarred:!character.isStarred } )"><star-icon :fillColor="character.isStarred ? '#fff' : '#11B0C8'" /></p></div>
      </div>
      <div v-if="!loading && !characters || !loading && characters.length < 1">No results</div>
      <div v-if="loading ">Loading</div>
      <div v-if="error ">An error occurred while loading. Try again later</div>
    <v-pagination
    v-model="page"
    :pages="queryInfo.pages"
    :range-size="1"
    :hideFirstButton="true"
    :hideLastButton="true"
    active-color="#11B0C8"
    @update:modelValue="updatePage"
    v-if="queryInfo.pages"
  />
  </section>
  </main>
</template>
<style scoped>
.gender-icon {
  display: flex;
  gap: 0.25rem;
  flex-wrap: nowrap;
  flex-direction: row;
  align-items: baseline;
}
.gender-icon span{
  position: relative;
  top: 5px;
}
.favourite-button{
  background-color: transparent;
  width: 43px;
  height: 43px;
  display: flex;
  align-items: center;
  justify-content: center;
  align-content: center;
  border-radius: 8px;
  border:2px solid #11B0C8;
}
.starred-character {
  background-color: #11B0C8;
}
</style>